/*
  nino.h

  The Nino object copies buffers from the ADC stream to the DAC stream.
  It assumes the ADC and DAC buffers are the same size.
  See the Be Newsletter #36 for a detailed description.
*/

#include <AudioSubscriber.h>

struct Nino : BObject
{
  Nino ();
  ~Nino ();

  char* buffer;						// The buffer to copy
  sem_id bufferReady;				// The buffer is ready to copy
  sem_id bufferUsed;				// The buffer has been copied
  BAudioSubscriber* adcSubscriber;	// ADC subscriber
  BAudioSubscriber* dacSubscriber;	// DAC subscriber
};
