/*
  slider.cpp

  LBSlider is a very simple slider control.
*/

#include "slider.h"

static const rgb_color stripe_color = {150, 20, 50, 0};

LBSlider::LBSlider (BRect r, char* name, int m)
  : BView (r, name, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW),	band (m)
{
  height = r.bottom - r.top;
  width = r.right - r.left;
  radius = width/2;
  stripe.Set (radius - 1, 0, radius + 1, height);
  rect1.Set (0, 0, radius - 2, height);
  rect2.Set (radius + 2, 0, width, height);
}

void
LBSlider::Draw (BRect)
{
  float x = (1 - value) * (height - 2 * radius);
  BRect button (0, x, width, x + width);
  SetHighColor (Parent()->ViewColor());
  FillRect (rect1);
  FillRect (rect2);
  SetHighColor (stripe_color);
  FillEllipse (button);
  FillRect (stripe);
}

void
LBSlider::MouseMoved (BPoint p, ulong transit, BMessage* message)
{
  BPoint curs;
  ulong buttons;
  GetMouse (&curs, &buttons, FALSE);
  if (buttons)
	SetValue (1 - (p.y - radius) / (height - 2 * radius));
}

void
LBSlider::SetValue (float v)
{
  if (v < 0)
	v = 0;
  if (v > 1)
	v = 1;
  if (value != v) {
	value = v;
	ValueChanged (value);
	Invalidate ();
  }
}
